#include <iostream>
#include <unistd.h>
#include <getopt.h>
#include "polynome.h"
#include "relayBox.h"
#include "voltageController.h"
#include "lightorgan.h"


using namespace std;

void usage(void);


int main (int argc, char * const argv[]) {
   
	if(argc==1) {
		usage();
		exit(EXIT_SUCCESS);
	}
	
	int option_index = 0, opt;
	static struct option loptions[] = {
		{"help",		no_argument,		NULL,	'h'},
		{"polynome",	no_argument,		NULL,	'p'},
		{"relay",		no_argument,		NULL,	'r'},
		{"vcontroller",	no_argument,		NULL,	'v'},
		{"lightorgan",	no_argument,		NULL,	'l'}
	};

	polynome p;
	relay r;
	voltageController vc;
	LightOrgan lo;
	
	
	while (1) {
		opt = getopt_long(argc, argv, "hprvl", loptions, &option_index);
		if (opt==-1) {
			break;
		}
		switch (opt) {
			case 'h':
				usage();
				exit(EXIT_SUCCESS);
				break;
			case 'p':
				p.start();
				break;
			case 'r':
				r.start();
				break;
			case 'v':
				vc.start();
				break;
			case 'l':
				lo.start();
				break;
			default:
				break;
		}
	}	
	char input = 0;
	while(input!='q') { 
		cin>>input;
	}
	exit(EXIT_SUCCESS);
}



void usage(void) {
    printf("Usage: polynomeSerial [OPTIONS]\n"
		   "\n"
		   "Options:\n"
		   "  -h, --help				Print this help message\n"
		   "  -p, --polynome			Start polynome router\n"
		   "  -r, --relay				Start relay router\n"
		   "  -v, --vcontroller			Start voltage controller router\n"
		   "  -l, --lightorgan			Start light organ controller\n"
		   "\n");
}
